import org.junit.Rule;
import org.junit.Test;
import org.junit.contrib.java.lang.system.StandardOutputStreamLog;
import org.junit.rules.Timeout;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.lang.reflect.Method;

import static org.junit.Assert.assertEquals;

public class Aufgabe2Test {

    @Rule
    public Timeout globalTimeout = new Timeout(100);

    @Rule
    public final StandardOutputStreamLog log = new StandardOutputStreamLog();

    @Test
    public void test() throws Exception {
        Method create = Aufgabe2.class.getDeclaredMethod("createArray", int.class, double[].class);
        assertEquals(true, create.getReturnType().equals(double[].class));
        create.setAccessible(true);
        Method print = Aufgabe2.class.getDeclaredMethod("printArray", double[].class, double[].class, int.class);
        assertEquals(true, print.getReturnType().equals(double.class));
        print.setAccessible(true);
        Method halve = Aufgabe2.class.getDeclaredMethod("halveArray", double[].class, double[].class);
        assertEquals(true, halve.getReturnType().equals(double[].class));
        halve.setAccessible(true);
        double[] p = {-1.0, 4.0};
        double[] q = {-100.0, 100.0};
        double[] r = {0.0, 100.0};
        double[] a = (double[])create.invoke(null, 0, p);
        double[] b = (double[])create.invoke(null, 1, q);
        double[] cp = (double[])create.invoke(null, 100, p);
        double[] cq = (double[])create.invoke(null, 100, q);
        double[] cr = (double[])create.invoke(null, 100, r);
        double[] d = (double[])create.invoke(null, 1000, r);
        assertEquals(0, a.length);
        assertEquals(1, b.length);
        assertEquals(100, cp.length);
        assertEquals(100, cq.length);
        assertEquals(100, cr.length);
        assertEquals(1000, d.length);
        assertEquals(true, sumup(cr) > 0.0);
        assertEquals(true, sumup(d) > 0.0);
        assertEquals(true, rangecheck(b, q));
        assertEquals(true, rangecheck(cp, p));
        assertEquals(true, rangecheck(cq, q));
        assertEquals(true, rangecheck(cr, r));
        assertEquals(true, rangecheck(d, r));
        assertEquals(null, create.invoke(null, 5, null));
        assertEquals(null, create.invoke(null, 5, new double[]{1.0}));
        assertEquals(null, create.invoke(null, 5, new double[]{1.0, 2.0, 3.0}));
        assertEquals(null, create.invoke(null, -5, r));
        assertEquals(0.0, print.invoke(null, cr, null, 1));
        assertEquals(0.0, print.invoke(null, null, r, 1));
        assertEquals(0.0, print.invoke(null, cr, r, -1));
        assertEquals(0.0, print.invoke(null, cr, new double[]{1.0}, 1));
        assertEquals(0.0, print.invoke(null, b, new double[]{1.0,2.0,3.0}, 1));
        assertEquals(null, halve.invoke(null, null, r));
        assertEquals(null, halve.invoke(null, b, null));
        assertEquals(null, halve.invoke(null, b, new double[]{1.0}));
        assertEquals(null, halve.invoke(null, b, new double[]{1.0,2.0,3.0}));

        System.out.println();
        System.out.println("Test-Output zu Aufgabe2:");

        String[] testValues = new String[]{
                "",
                "Test-Output zu Aufgabe2:",
                "-1.0 1.5 0",
                "1.5 4.0 0",
                "0.0 100.0 15",
                "-100.0 -60.0 0",
                "-60.0 -20.0 0",
                "-20.0 20.0 5",
                "20.0 60.0 6",
                "60.0 100.0 4",
                "0.0 10.0 4",
                "10.0 20.0 1",
                "20.0 30.0 1",
                "30.0 40.0 1",
                "40.0 50.0 2",
                "50.0 60.0 2",
                "60.0 70.0 1",
                "70.0 80.0 1",
                "80.0 90.0 1",
                "90.0 100.0 1",
                "0.0 12.5 6",
                "12.5 25.0 3",
                "25.0 37.5 3",
                "37.5 50.0 3"
        };
        StringBuilder testString = new StringBuilder();
        for(String i: testValues) {
            testString.append(i).append(System.lineSeparator());
        }

        b = new double[]{1.0, 33.4, 12.3, 44.5, 89.2, 44.3, 99.9, 3.0, 0.0, 5.8, 22.9, 66.6, 77.7, 54.3, 55.5};
        assertEquals(2.5, print.invoke(null, a, p, 2));
        assertEquals(100.0, print.invoke(null, b, r, 1));
        assertEquals(40.0, print.invoke(null, b, q, 5));
        assertEquals(10.0, print.invoke(null, b, r, 10));
        d = (double[])halve.invoke(null, b, r);
        assertEquals(0.0, d[0], 1e-6);
        assertEquals(50.0, d[1], 1e-6);
        print.invoke(null, b, d, 4);

        assertEquals(testString.toString(), log.getLog());
    }

    private static double sumup(double[] array) {
        double sum = 0;
        for (double v : array) {
            sum += v;
        }
        return sum;
    }

    private static boolean rangecheck(double[] array, double[] range) {
        for (double v : array) {
            if (v < range[0] || v >= range[1]) {
                return false;
            }
        }
        return true;
    }
}
