import org.junit.Rule;
import org.junit.Test;
import java.lang.reflect.Method;
import org.junit.rules.Timeout;

import static org.junit.Assert.assertEquals;

public class Aufgabe5Test {

    @Rule
    public Timeout globalTimeout = new Timeout(100);

    @Test
    public void testSum() throws Exception {
        Method method = Aufgabe5.class.getDeclaredMethod("sum", int[].class, int.class);
        assertEquals(true, method.getReturnType().equals(Integer.TYPE));
        method.setAccessible(true);
        assertEquals(0, method.invoke(null, null, 0));
        assertEquals(0, method.invoke(null, new int[]{}, 0));
        assertEquals(10, method.invoke(null, new int[]{5, 4, 3, 2, 1, -5, -6}, 5));
        assertEquals(4, method.invoke(null, new int[]{5, 4, 3, 2, 1, -5, -6}, 6));
        assertEquals(0, method.invoke(null, new int[]{5, 4, 3, 2, 1, -5, -6}, -1));
        assertEquals(0, method.invoke(null, new int[]{5, 4, 3, 2, 1, -5, -6}, 7));
    }

    @Test
    public void testSpan() throws Exception{
        Method method = Aufgabe5.class.getDeclaredMethod("span", int[][][].class);
        assertEquals(true, method.getReturnType().equals(Integer.TYPE));
        method.setAccessible(true);
        assertEquals(-1, method.invoke(null, new Object[]{null}));
        assertEquals(-1, method.invoke(null, new Object[]{new int[][][]{null, {{-5, 3}}, {{8}, {4}}}}));
        assertEquals(-1, method.invoke(null, new Object[]{new int[][][]{{{-5}, {3}}, null, {{8, 4}}}}));
        assertEquals(-1, method.invoke(null, new Object[]{new int[][][]{{{-5}, {3}}, {{8}, {4}}, {}, {null}}}));
        assertEquals(-1, method.invoke(null, new Object[]{new int[][][]{{{}}}}));
        assertEquals(-1, method.invoke(null, new Object[]{new int[][][]{{{}}, {}}}));
        assertEquals(8, method.invoke(null, new Object[]{new int[][][]{{}, {{-5}, {0, 3}}}}));
        assertEquals(8, method.invoke(null, new Object[]{new int[][][]{{{}}, {{3, 0}, {-5}}}}));
        assertEquals(8, method.invoke(null, new Object[]{new int[][][]{{{3}, {2, 1}}, {{3}, {0}, {-5}}, {{-1}}}}));
        assertEquals(8, method.invoke(null, new Object[]{new int[][][]{{{-5, 2, 1}}, {{3, 0, 3}}, {{-1}}}}));
    }

    @Test
    public void testPrimes() throws Exception{
        Method method = Aufgabe5.class.getDeclaredMethod("primes", int[].class, int.class);
        method.setAccessible(true);
        method.invoke(null, null, 0);
        int[] a = new int[0];
        method.invoke(null, a, 0);
        assertEquals(true, cmp(a));
        int[] b = new int[]{2, 3, 0, 0, 0};
        method.invoke(null, b, 2);
        assertEquals(true, cmp(b, 2, 3, 5, 7, 11));
        int[] c = new int[10];
        method.invoke(null, c, 0);
        assertEquals(true, cmp(c, 2,3,5,7,11,13,17,19,23,29));
    }

    @Test
    public void testDiv() throws Exception{
        Method method = Aufgabe5.class.getDeclaredMethod("div", int.class, int.class);
        assertEquals(true, method.getReturnType().equals(int[].class));
        method.setAccessible(true);
        assertEquals(true, cmp((int[])method.invoke(null, 8, 3), 2, 2));
        assertEquals(true, cmp((int[])method.invoke(null, 3, 8), 0, 3));
        assertEquals(true, cmp((int[])method.invoke(null, 0, 3), 0, 0));
    }

    private static boolean cmp(int[] a, int... b) {
        if (a.length != b.length) {
            return false;
        }
        for (int i = 0; i < a.length; i++) {
            if (a[i] != b[i]) {
                return false;
            }
        }
        return true;
    }
}